<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_tipo_calculo_data.php");
class Bi_tipo_calculo_dataDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_tipo_calculo_data)
	{
		$inputs = array();
		if($bi_tipo_calculo_data->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_tipo_calculo_data->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_tipo_calculo_data->getTipo() != "")
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>$bi_tipo_calculo_data->getTipo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_tipo_calculo_data (codigo, tipo) VALUES (:codigo, :tipo)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_tipo_calculo_data($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_tipo_calculo_data where codigo = :codigo "; 
		$bi_tipo_calculo_data = new Bi_tipo_calculo_data();
		$rows_bi_tipo_calculo_data = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_tipo_calculo_data as $row)
		{
			$bi_tipo_calculo_data->setCodigo($row['codigo']);
			$bi_tipo_calculo_data->setTipo($row['tipo']);
		}
		return $bi_tipo_calculo_data;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_calculo_data  ".$where;
		$lista_bi_tipo_calculo_data = array();
		$rows_bi_tipo_calculo_data = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_calculo_data as $row)
		{
			$bi_tipo_calculo_data = new Bi_tipo_calculo_data();
			$bi_tipo_calculo_data->setCodigo($row['codigo']);
			$bi_tipo_calculo_data->setTipo($row['tipo']);
			array_push($lista_bi_tipo_calculo_data, $bi_tipo_calculo_data);
		}
		return $lista_bi_tipo_calculo_data;
	}
	public function atualizar($bi_tipo_calculo_data)
	{
		$inputs = array();
		if($bi_tipo_calculo_data->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_tipo_calculo_data->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_tipo_calculo_data->getTipo() != "")
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>$bi_tipo_calculo_data->getTipo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_tipo_calculo_data  SET codigo = :codigo, tipo = :tipo WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_tipo_calculo_data)
	{
		try
		{
			$sql = "DELETE FROM bi_tipo_calculo_data  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_tipo_calculo_data->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_calculo_data";
		$listaBi_tipo_calculo_data = array();
		$rows_bi_tipo_calculo_data = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_calculo_data as $row)
		{
			$bi_tipo_calculo_data = new Bi_tipo_calculo_data();
			$bi_tipo_calculo_data->setCodigo($row['codigo']);
			$bi_tipo_calculo_data->setTipo($row['tipo']);
			array_push($listaBi_tipo_calculo_data,$bi_tipo_calculo_data );
		}
		return $listaBi_tipo_calculo_data;
	}
	public function buscarBi_tipo_calculo_dataPorTipo($tipo)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_tipo_calculo_data where tipo like '%".$tipo."%'";
		$lista_bi_tipo_calculo_data = array();
		$rows_bi_tipo_calculo_data = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_tipo_calculo_data as $row)
		{
			$bi_tipo_calculo_data = new Bi_tipo_calculo_data();
			$bi_tipo_calculo_data->setCodigo($row['codigo']);
			$bi_tipo_calculo_data->setTipo($row['tipo']);
			array_push($lista_bi_tipo_calculo_data, $bi_tipo_calculo_data);
		}
		return $lista_bi_tipo_calculo_data;
	}
}